//************************************************************
//		detect.c  ,  Mm[`
//			Copyright by S.Asakura
//************************************************************
#include 	<m8c.h>			// part specific constants and macros
#include 	"PSoCAPI.h" 	// PSoC API definitions for all User Modules

//*******************************
//		O֐
//*******************************
#include	"printf.h"		// printf to
#include	"message.h"		// bZ[W\
#include	"bpf.h"			// ohpXEtB^
#include	"rtc-inner.h"	// RTCA^C NbN
#include	"jihou.h"		// 񃋁[`
#include	"etc.h"			// X̃[eBeBE[`

//*******************************
// 萔 `Cvg^Cv錾CO[oϐ
//*******************************
#define 	FIRST_FLG		// ŏɕϐ̒`C2ڈȍ~͊Oϐ錾邽߂̃tO
#include	"detect.h"		// Mm[`

//*******************************
//	O[oϐ
//*******************************

//                      [Xe[^X]     0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10   
const unsigned char  t50ms[N_STAT]  = {  0,  2,  9, 12, 19, 22, 27, 40, 45, 70, 70 };		// mԂ̏I(~0.1sec)
const unsigned char  f0num[N_STAT]  = {  0,  0,  0,  0,  0,  0,  0,  1,  1,  0,  0 };		// BPFSg_ԍ
const unsigned short pJudge[N_STAT] = {  0, 34,  1, 34,  1, 34,  1,  0,  0,  0,  0 };		// pX_()
const unsigned char  jLower[N_STAT] = {  0,  0,  1,  0,  1,  0,  1,  0,  0,  0,  0 };		// 0:ȏ , 1:ȉ𔻒肷


//=========================================================================


//********************
// mXe[^X\
//********************
void disp_detStat(void) {
	extern	unsigned short	sig3PulseCount;		// M3 pXJEg
	extern	unsigned char	sigStat;			// M mXe[^X
	extern	unsigned char	preStat;			// O̐MmXe[^X
	extern	unsigned char	detStatVisible;		// mXe[^X\tO, 0=\, 1=v_\, 2=S\
	extern	unsigned short	*ptr_bpf_f0;		// bpf_f0[ ] ւ̃|C^

	if ( (detStatVisible >= 1) && (sigStat != preStat) ) {
		set_prtdev_sio(); 				// \uSIO(UART)ɂ
		printf(",(%d", sigStat);								// (M1mXe[^X, 
		printf(",%d", *(ptr_bpf_f0 + f0num[sigStat] ) );		// g, 
		printf(",%d)", sig3PulseCount);							// JEgl), 
		preStat = sigStat;					// O̐MmXe[^X
	} // end if
}

//*******************************
// DigBuf_3 荞݃[`
//*******************************
#pragma interrupt_handler DigBuf_3_ISR
void DigBuf_3_ISR(void) {
	extern	unsigned short	sig3PulseCount;			// M3 pXJEg
	extern	unsigned char	sigStat;				// M mXe[^X
	extern	unsigned char	jDetFlg;				// 񌟏otO, 0=o, 1=o
	extern	unsigned short	JADelay;				// Z x(b)

	if (sigStat == 0 && ct8_detForm_intCount == 0) {
		sigStat = 1;					//	 1 : 440Hz ŏ1m 0.1secJEg
		chgBPF_f0( 0 );		// Ô	// tC^g_؊ , gԍ 0=440Hz , 1=880Hz
		Counter8_detForm_Stop();					// Counter8_detForm ~
		Counter8_detForm_WritePeriod(CT8dF_DIV - 1);	// JEglZbg
		sig3PulseCount = 0;							// M3 pXJEg NA
		Counter8_detForm_Start();					// Counter8_detForm X^[g
		Counter8_detForm_EnableInt();				// Counter8_detForm ݋
	} // end if sigStat
	if (sigStat == (M3_END_STAT - 1)) {
		sigStat = M3_END_STAT;			//  8 :  팟m1
		Counter16_JAdj1_Stop();			// Counter16_JAdj1 ~Cォ󂯕tD悳
		Counter8_JAdj0_Stop();			// Counter8_JAdj0 ~
		Counter16_JAdj1_WritePeriod(JADelay - 1);	// JEglZbg
		Counter8_JAdj0_WritePeriod(99);				// JEglZbg
		Counter8_JAdj0_Start();			// Counter8_JAdj0 X^[g
		Counter16_JAdj1_Start();		// Counter16_JAdj1 X^[g
		Counter16_JAdj1_EnableInt();	// Counter16_JAdj1 ݋
		jDetFlg = 1;					// 񌟒mtO, 0=m, 1=m
		sig3PulseCount = 0;				// M3 pXJEg NA
	} // end if sigStat
	sig3PulseCount++;					// M3 pXJEg3 Inc
}

//********************
// DigBuf_3 荞ݏ Enable
//   2930b̋ߖTŐMM֎~ , Z𐳊mɂ
//   荞݂̗\񂪗LĂȂBɂ ENSWINTNA𔺂C
//   v̊NbNꎞIɋ֎~AׁB
//********************
void cntl_dBuf3IntEnable(void) {
	extern	unsigned char	jDetFlg;		// 񌟏otO, 0=o, 1=o
	extern	unsigned char	second;			// 0-59 seconds
	extern	unsigned char	minute;			// 0-59 minutes
	unsigned short ct16count;

	ct16count = Counter16_JAdj1_wReadCounter();
	// 2930b̋ߖTŐMM֎~
	if ((jDetFlg == 1) && (ct16count == 1)) {	// 񌟏o && Z1bO
		DigBuf_3_DisableInt();	// DigBuf_3 ݋֎~
		clr_detStat();			// mXe[^X NACACh
	} // end if

	// 2931bŐMM
	if ((jDetFlg == 0) && (minute == J_ADJ_MIN) && (second == (J_ADJ_SEC + 1))) {
		DigBuf_3_EnableInt();	// DigBuf_3 ݋
		clr_detStat();			// mXe[^X NACACh
	} // end if
}

//*******************************
//	Counter8_detForm_ISR 荞݃[`i0.1bj
//	MtH[}bgmF
//	ŏ1ڂ̐MpXmɓ삷
//*******************************
#pragma interrupt_handler Counter8_detForm_ISR
void Counter8_detForm_ISR(void) {
	extern	unsigned short	sig3PulseCount;			// M3 pXJEg
	extern	unsigned char	ct8_detForm_intCount;	// ct8_detForm荞݉񐔃JEg
	extern	unsigned char	sigStat;				// M mXe[^X
	extern	unsigned char	jDetFlg;				// M mtO, 0=m, 1=1񌟒m, 2=2񌟒m, ...

	M8C_EnableGInt;					// d荞݋
	ct8_detForm_intCount++;								// `JEg+1
	if ( (sigStat < M3_END_STAT) && (ct8_detForm_intCount == t50ms[sigStat]) ) { 	// Ԃ̏IȂ
		disp_detStat();			// mXe[^X\(SIO)
		if ( ((jLower[sigStat] == 0) && (sig3PulseCount >= pJudge[sigStat])) || 	// yA1̃pX
			 ((jLower[sigStat] == 1) && (sig3PulseCount <= pJudge[sigStat])) ) {	// ĂȂ
			sigStat++;						// mXe[^X+1
			if (sigStat == (M3_END_STAT - 1)) {		// sigStat == 7
				chgBPF_f0( f0num[sigStat] );		// tC^g_؊ , gԍ 0=440Hz , 1=880Hz
			} // end if
			sig3PulseCount = 0;				// M3 pXJEg NA
		} else {
			clr_detStat();				// mXe[^X NACACh
		} // end if sig3PulseCount
	} else if ( ct8_detForm_intCount >= t50ms[(N_STAT - 1)] ) { 	// 7bȏ
		clr_detStat();				// mXe[^X NACACh
	} // end if ct8_detForm_intCount
}

//*******************************
//	mXe[^X NACACh
//*******************************
void clr_detStat(void) {
	extern	unsigned short	sig3PulseCount;			// M3 pXJEg
	extern	unsigned char	ct8_detForm_intCount;	// ct8_detForm荞݉񐔃JEg
	extern	unsigned char	sigStat;				// M mXe[^X
	extern	unsigned char	preStat;				// O̐MmXe[^X
	extern	unsigned char	jAdjEnable;				// ZCl[u, 0=Z֎~, 1=Z

	Counter8_detForm_Stop();		// Counter8_detForm ~
	Counter8_detForm_DisableInt();	// Counter8_detForm 荞݋֎~
	Counter8_detForm_WritePeriod(CT8dF_DIV - 1);	// JEglZbg
	chgBPF_f0( 0 );					// tC^g_؊ , gԍ 0=440Hz , 1=880Hz
	sigStat = 0;					// M mXe[^X ,  0 : ACh
	preStat = 0;					// O̐MmXe[^X
	ct8_detForm_intCount = 0;		// ct8_detForm荞݉񐔃JEg NA
	sig3PulseCount = 0;				// M3 pXJEg NA
}

//*******************************
//	Mm 
//*******************************
void init_Det(void) {
	extern	unsigned char	fixedMode;		// Œ胂[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:

	DigBuf_3_Start();		// DigBuf_3 X^[g
	clr_detStat();			// mXe[^X NACACh
	chgBPF_f0( 0 );			// tC^g_؊ , gԍ 0=440Hz , 1=880Hz
	CMPPRG_3_SetRef( CMPPRG_3_REF0_250 ); 	// CMPPRG_3 臒l ݒ
	DigBuf_3_EnableInt();	// DigBuf_3 ݋
}

//********************
// HELP mR}h('D')
//********************
void help_Det(void) {
	UART_1_CPutString(" DVx ; Visible, x=0:Normal, 1:Detail");
	UART_1_PutCRLF();					// s(CR,LF)
}

//*******************************
// MmR}h('D') 
//*******************************
void cmdBR_Det(unsigned char *str) {
	extern	unsigned char	fixedMode;		// Œ胂[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned char	detStatVisible;	// mXe[^X\tO, 0=\, 1=\
	unsigned char *strPtr;
	unsigned char num;

	set_prtdev_sio(); 				// \uSIO(UART)ɂ
	strPtr = str;
	strPtr++;
	switch (*strPtr) {
		case 'V' : 		// Xe[^XVisible
		case 'v' : 
			strPtr++;
			if ( (num = hexChar2num(*strPtr, 2)) <= 2 ) {
				detStatVisible = num;		// mXe[^X\tO, 0=\, 1=v_\, 2=S\
			} else {
				detStatVisible = 0;			// mXe[^X\tO, 0=\
			} // end if
			if ( detStatVisible == 1 ) {
				UART_1_CPutString("Detail-Disp");
				UART_1_PutCRLF();					// s(CR,LF)
			} else {
				UART_1_CPutString("Normal-Disp");
				UART_1_PutCRLF();					// s(CR,LF)
			} // end if
			break;
		default : 
			msg_InvalCmd();			// \_R}h
			help_Det();				// HELP DetR}h
			break;
	} // end switch cmd[1]
}

