//************************************************************
//		C [`
//************************************************************
#include 	<m8c.h>			// part specific constants and macros
#include 	"PSoCAPI.h" 	// PSoC API definitions for all User Modules
#include 	<string.h>

//*******************************
//		O֐
//*******************************
#include	"uart.h"			// UART VAʐM
#include	"printf.h"			// printf to
#include	"message.h"			// bZ[W\
#include	"bpf.h"				// ohpXEtB^
#include	"rtc-inner.h"		// RTCA^C NbN
#include	"detect.h"			// Mm[`
#include	"jihou.h"			// 񃋁[`
#include	"rtc-alarm.h"		// RTCA[
#include	"version.h"			// o[WC쐬ȂǕ\

//*******************************
//	萔 `
//	vg^Cv錾
//	O[oϐ
//*******************************
#define 	FIRST_FLG		// ŏɕϐ̒`C2ڈȍ~͊Oϐ錾邽߂̃tO
#include	"main.h"		// C [`

//=========================================================================

//********************
// n[hEFA 
//********************
void init_Hard(void) {
	//*****  LCD  *****
	LCD_1_Start();					// Initialize LCD hardware
	set_prtdev_lcd();				// printf\foCXLCDɐ؊
	lcd_cls_home();					// LCD ʃNA & \ʒuHOME
	//*****  UART  *****
	init_UART();					// UART_1 ( Counter8) 
	M8C_EnableGInt;					// O[o݋
	//*****
	init_BPF();						// ohpXEtB^ 
	initRTC();						// RTC 
	init_Det();						// Mm 
	init_Jihou();					//  
	init_rtcAlarm();				// RTCA[
}

//********************
// t \(LCD) 1b
//********************
void dispDateTimeLCD(void) {
	set_prtdev_lcd();				// \uLCDɂ
	lcd_home();						// LCD\ʒuHOME
	rtc_inner_dispDate();			// RTC t(N(j)) READ & \
	dispJStatLCD();					// Xe[^X\(LCD)
	printCRLF();					// s(CR,LF)
	rtc_inner_dispTime();			// RTC (b) \
}

//********************
//   00b , SIO\
//********************
void regularJob00s(void) {
	extern	unsigned long	mesCount;	// JEg
	extern	unsigned char	second;		// 0-59 seconds

	if (second == 00) {
		set_prtdev_sio(); 				// \uSIO(UART)ɂ
		UART_1_PutCRLF();					// s(CR,LF)
		mesCount++ ;						// JEg INC
		printf("%08d , ", mesCount);		// JEg  \
		rtc_inner_dispDate();				// RTC t(N(j)) READ & \
		UART_1_CPutString(" , ");			// J}(" , ")
		rtc_inner_dispTime();				// RTC (b) \
	} // end if
}

//********************
//  	\
//********************
void init_Disp(void) {
	extern unsigned long mesCount;	// JEg

	dispDateTimeLCD();			// t \(LCD) 1b
	set_prtdev_sio(); 			// \uSIO(UART)ɂ
	UART_1_PutCRLF();			// s(CR,LF)
	UART_1_PutCRLF();			// s(CR,LF)
	dispVer();					// o[W\
	UART_1_PutCRLF();			// s(CR,LF)
	disp_rtcAlm_Set();			// RTCA[ݒ S\
	UART_1_PutCRLF();			// s(CR,LF)
	print_pads(47, (unsigned int)'=');	//  no
	UART_1_PutCRLF();			// s(CR,LF)
	UART_1_CPutString("mesCount ,     Date        ,   Time   , Comment\r\n");
	print_pads(47, (unsigned int)'=');	//  no
	UART_1_PutCRLF();			// s(CR,LF)
	mesCount = (unsigned long)(0);		// JEg
}

//********************
// HELP C
//********************
void help_Main(void) {
	set_prtdev_sio(); 		// \uSIO(UART)ɂ
	UART_1_PutCRLF();			// s(CR,LF)
	dispVer();				// o[W\
	UART_1_PutCRLF();			// s(CR,LF)
	UART_1_CPutString(" H   ; Help");
	UART_1_PutCRLF();			// s(CR,LF)
	UART_1_PutCRLF();			// s(CR,LF)
	help_Clock();			// HELP ClockR}h('C')
	UART_1_PutCRLF();			// s(CR,LF)
	help_Det();				// HELP mR}h('D')
	UART_1_PutCRLF();			// s(CR,LF)
	help_rtcAlarm();		// HELP RTCA[ R}h('A')
	UART_1_PutCRLF();			// s(CR,LF)
	disp_rtcAlm_Set();		// RTCA[ݒ S\
	UART_1_PutCRLF();			// s(CR,LF)
}

//********************************************************
// 		C [`
//********************************************************
void main(void) {
	extern	unsigned char	ct8_P1_int1sec;	// ct8_P1PbʒmtO
	extern	unsigned char	jAdjEnable;		// ZCl[u, 0=Z֎~, 1=Z
	unsigned char	*strPtr;
	unsigned char 	sLen;		// 񒷂

	init_Hard();		// n[hEFA 
	init_Disp();		// \
	while(TRUE) {
		if (ct8_P1_int1sec != 0) {			// 1bo߂
			jAdjEnable = 0;					// ZCl[u, 0=Z֎~, 1=Z 
			if (ct8_P1_int1sec != 0) {			// 1bo߂ă`FbNDZsĂ0NAĂ͂
				ct8_P1_int1sec  = 0;			// ct8_P1PbʒmtO NA
				rtc_inner_Tick1sec();			// RTC 1b
				jAdjEnable = 1;					// ZCl[u, 0=Z֎~, 1=Z 
				dispDateTimeLCD();				// t \(LCD) 1b
				chk_rtcAlarm();					// RTCA[_`FbN
				regularJob00s();				// _00b, SIO\
				dispJihouStat();				// Xe[^X\(SIO)
				disp_rtcAlm_Stat();				// RTCA[ \
				cntl_dBuf3IntEnable();			// DigBuf_3 荞ݏ Enable(2930b̋ߖT)
				// KvɉāCɒǉDS1bȓ̏ԂɂD
			} // end if int1sec 
			jAdjEnable = 1;					// ZCl[u, 0=Z֎~, 1=Z 
		} // end if int1sec

		// R}h
		set_prtdev_sio(); 				// \uSIO(UART)ɂ
		if(UART_1_bCmdCheck()) {						// Wait for command
			if(strPtr = UART_1_szGetParam()) {			// More than delimiter?
				sLen = strlen(strPtr);
				if (sLen <= 127) {
					printf("\r\nCommand = \"%s\"\r\n", strPtr); 	// R}he\
					switch (*strPtr) {
						case 'C' : 
						case 'c' : 
							cmdBR_RTC(strPtr);		// RTCR}h('Clock') 
							break;
						case 'D' : 
						case 'd' : 
							cmdBR_Det(strPtr);		// MmR}h('D') 
							break;
						case 'A' : 
						case 'a' : 
							cmdBR_rtcAlarm(strPtr);		// RTCA[ R}h('A') 
							break;
						case 'H' : 					// HELPR}h
						case 'h' : 
							help_Main();			// HELP C
							break;
						default : 
							msg_InvalCmd();			// \_R}h
							help_Main();			// HELP C
							break;
					} // end switch cmd[0]
				} else {
					msg_InvalCmd();			// \_R}h
				} // end if strlen
			} // end if szGetParam
		UART_1_CmdReset();					// Reset command buffer
		} // end if bCmdCheck
	} // end while
}

